Whamcloud - gitweb
b=16312
[fs/lustre-release.git] / build / lbuild
1 #!/bin/bash
2
3 # vim:expandtab:shiftwidth=4:softtabstop=4:tabstop=4:
4
5 #set -x
6 shopt -s extdebug
7
8 TOPDIR=$PWD
9
10 # CVSROOT is inherited from the environment
11 KERNELDIR=
12 LINUX=
13 LUSTRE=
14 RELEASE=false
15 # XXX - some recent hacking has pretty much neutered this option.
16 #       search through this file (and lbuild.old_school -- but that will
17 #       be going away soon) for "-bb" and see how many places
18 #       simply don't account for this option
19 DO_SRC=false
20 DOWNLOAD=true
21 TAG=
22 CANONICAL_TARGET=
23 TARGET=
24 TARGET_ARCH=$(uname -m)
25 TARGET_ARCHS=
26 TARGET_ARCHS_ALL=$TARGET_ARCH
27 [ "$TARGET_ARCH" = "i686" ] && TARGET_ARCHS_ALL="i686 i586 i386"
28 CONFIGURE_FLAGS=
29 EXTERNAL_PATCHES=
30 EXTRA_VERSION=
31 LUSTRE_EXTRA_VERSION=
32 STAGEDIR=
33 TMPDIR=${TMPDIR:-"/var/tmp"}
34 TIMESTAMP=
35 # XXX - i think these two parameters/arguments/variables need to be
36 #       cleaned up and merged.  they effectively do the same thing
37 REUSERPM=
38 REUSEBUILD=
39 # what does this do exactly?  does it imply no kernel build?
40 NORPM=false
41 LDISKFSRPM=true
42 SKIPLDISKFSRPM="v1_4_* b1_4"
43 SMPTYPES="smp bigsmp default ''"
44 KERNCONFSMPTYPE=
45 PATCHLESS=false
46 XEN=false
47 LINUXOBJ=
48 DISTRO=
49 KERNELTREE=
50
51 # patchless build
52 KERNELRPMSBASE=
53 RPMSMPTYPE=
54
55 # from target file
56 SERIES=
57 BASE_ARCHS=
58 BIGMEM_ARCHS=
59 BOOT_ARCHS=
60 JENSEN_ARCHS=
61 SMP_ARCHS=
62 BIGSMP_ARCHS=
63 PSERIES64_ARCHS=
64 UP_ARCHS=
65
66 # not in the target file any more
67 CONFIG=
68
69 DATE=$(date)
70
71 USE_DATESTAMP=1
72 RPMBUILD=
73
74 OLD_SCHOOL=false
75
76 export CC=${CC:-gcc}
77
78 # Readlink is not present on some older distributions: emulate it.
79 readlink() {
80     local path=$1 ll
81
82     if [ -L "$path" ]; then
83         ll="$(LC_ALL=C ls -l "$path" 2> /dev/null)" &&
84         echo "${ll/* -> }"
85     else
86         return 1
87     fi
88 }
89
90 cleanup() {
91
92     true
93 }
94
95 error() {
96     local msg="$1"
97
98     [ -n "$msg" ] && echo -e "\n${0##*/}: $msg" >&2
99
100 }
101
102 fatal() {
103
104     cleanup
105     error "$2"
106     exit $1
107
108 }
109
110 usage() {
111     cat <<EOF
112 Usage: ${0##*/} [OPTION]... [-- <lustre configure options>]
113
114   -d CVSROOT
115     Specifies the CVS Root to use when pulling files from CVS.  The
116     environment variable \$CVSROOT is used if this option is not
117     present.
118
119   --external-patches=EXTERNAL_PATCHES
120     Directory similar to lustre/lustre/kernel_patches/ that lbuild should
121     look for seres and config files in before looking in the lustre
122     tree.
123
124   --extraversion=EXTRAVERSION
125     Text to use for the rpm release and kernel extraversion.
126
127   --timestamp=TIMESTAMP
128     Date of building lustre in format YYYYMMDDhhmmss
129
130   --reuserpm=DIR
131     Try to reuse old kernel RPMs from DIR
132
133   --reusebuild=DIR
134     Try to reuse old kernel builds from DIR
135
136   --kernelrpm=DIR
137     Path to distro kernel RPM collection
138
139   --ccache
140     Use ccache
141
142   --norpm
143     Do not build RPMs (compile only mode)
144
145   --patchless
146     Build lustre client only
147
148   --distro=DISTRO
149     Which distro using. Autodetect by default
150
151   --kerneldir=KERNELDIR
152     Directory containing Linux source tarballs referenced by target
153     files.
154
155   --kerneltree=KERNELTREE
156     Directory containing dirs with Linux source tarballs referenced by target
157     files. Dir names in format kernel version ('2.6.9', etc.)
158
159   --linux=LINUX --with-linux=LINUX
160     Directory of Linux kernel sources.  When this option is used, only
161     Lustre modules and userspace are built.
162
163   --lustre=LUSTRE
164     Path to an existing lustre source tarball to use instead of
165     pulling from CVS.
166
167   --nodownload
168     Do not try to download a kernel from downloads.lustre.org
169
170   --nosrc
171     Do not build a .src.rpm, a full kernel patch, or a patched kernel
172     tarball.
173
174   --ldiskfs
175     Do ldiskfs RPM. Now true by default
176
177   --publish
178     Unused.
179
180   --release
181     Specifies that the files generated do not include timestamps, and
182     that this is an official release.
183
184   --src
185     Build a .src.rpm, a full kernel patch, and a patched kernel tarball.
186
187   --stage=DIR
188     Directory used to stage packages for release.  RPMs will be placed
189     more or less in DIR/<target>-<arch>, and the tarball will be
190     placed in DIR.
191
192   --tag=TAG
193     A CVS branch/tag name to build from when pulling from CVS.
194
195   --target=TARGET
196     The name of the target to build.  The available targets are listed
197     below.
198
199   --target-archs=TARGET_ARCHS
200     A (space delimited) list of architectures to build.  By default,
201     all of the archs supported by the TARGET will be built, in
202     addition to a .src.rpm.  This option can limit those, for machines
203     that can only build certain archs or if you only want a certain
204     arch built (for testing, or a one-off kernel).
205
206     Also note that by using a non-"base" arch (eg, i386) only kernels
207     will be built - there will be no lustre-lite-utils package.
208
209   --disable-datestamp
210     Prevents the datestamp flag (-D) from being passed to cvs for
211     checkouts. This is a workaround for a problem encountered when
212     using lbuild with tinderbox.
213
214   --xen
215     Builds a Xen domX kernel.
216
217 EOF
218
219 #   list_targets
220
221     fatal "$1" "$2"
222 }
223
224 # canonicalize a relative path
225 canon_path() {
226     local PATH="$1"
227
228     if [ ! -d "$PATH" ]; then
229         return 1
230     fi
231
232     pushd "$PATH" >/dev/null || return 1
233     local CANONPATH=$PWD
234     popd >/dev/null
235
236     echo "$CANONPATH"
237     return 0
238 }
239
240 check_options() {
241
242     if [ "$LUSTRE" ]; then
243         [ -r "$LUSTRE" ] || \
244             usage 1 "Could not find Lustre source tarball '$LUSTRE'."
245     else
246         [ "$CVSROOT" ] || \
247             usage 1 "Either specify a CVS Root with -d, or a Lustre source tarball with --lustre."
248         [ "$TAG" ] || \
249             usage 1 "A branch/tag name must be specified with --tag when not building from a tarball."
250     fi
251
252     if [ -z "$LINUX" ]; then
253         [ "$KERNELDIR" -o "$KERNELTREE" ] || \
254             usage 1 "A kernel directory must be specified with --kerneldir or --kerneltree."
255
256         [ -d "$KERNELDIR" -o -d "$KERNELTREE" ] || \
257             usage 1 "$KERNELDIR and $KERNELTREE are not a directory."
258
259         if ! $RELEASE; then
260             [ "$TAG" ] || \
261                 usage 1 "When building a snapshot, a tag name must be used."
262         fi
263
264         [ "$TARGET" ] || usage 1 "A target must be specified with --target."
265 #       TARGET_FILE="$TOPDIR/lustre/kernel_patches/targets/$TARGET.target"
266 #       [ -r "$TARGET_FILE" ] || \
267 #               usage 1 "Target '$TARGET' was not found."
268     fi
269
270     case $TARGET in
271         2.6-rhel5)
272             CANONICAL_TARGET="rhel5"
273             ;;
274         2.6-rhel4)
275             CANONICAL_TARGET="rhel-2.6"
276             ;;
277         2.6-suse)
278             CANONICAL_TARGET="sles-2.6"
279             ;;
280         2.6-sles10)
281             CANONICAL_TARGET="sles10-2.6"
282             ;;
283         hp_pnnl-2.4)
284             CANONICAL_TARGET="hp-pnnl-2.4"
285             ;;
286         2.6-vanilla \
287             | suse-2.4.21-2 \
288             | rh-2.4 \
289             | rhel-2.4 \
290             | sles-2.4 \
291             | 2.6-patchless)
292                 CANONICAL_TARGET="$TARGET"
293                 ;;
294     esac
295
296     local timestampnodig=$(echo $TIMESTAMP | sed -e s/[0-9]*//g)
297     [ "$timestampnodig" = "" ] || TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
298     local timestamplength="${#TIMESTAMP}"
299     if [ $timestamplength -eq 12 ]; then
300         TIMESTAMP="${TIMESTAMP}00"
301     elif [ $timestamplength -ne 14 ]; then
302         TIMESTAMP=$(date -d "$DATE" "+%Y%m%d%H%M%S")
303     fi
304
305     RPMBUILD=$(which rpmbuild 2>/dev/null | head -1)
306     if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
307         RPMBUILD=$(which rpm 2>/dev/null | head -1)
308         if [ ! "$RPMBUILD" -o "$RPMBUILD" == "" ]; then
309             usage 1 "Could not find binary for making rpms (tried rpmbuild and rpm)."
310         fi
311     fi
312
313     if [ -n "$CCACHE" ]; then
314         which "$DISTCC" 2>/dev/null && export DISTCC RPM_BUILD_NCPUS
315
316         if which "$CCACHE" 2>/dev/null; then
317             local ccache=$(which "$CCACHE")
318             local bindir="$TOPDIR/bin"
319
320             [ -d $bindir ] || mkdir -p $bindir
321             if [ -d $bindir ]; then
322                 rm ${bindir}/* > /dev/null 2>&1
323                 ln -s "$ccache" ${bindir}/ccache
324                 ln -s "$ccache" ${bindir}/cc
325                 ln -s "$ccache" ${bindir}/$CC
326                 export PATH=$bindir:$PATH
327             fi
328             export CCACHE && export CC="ccache $CC"
329             # zero the cache so we can see how effective we are being with it
330             ccache -z
331         fi
332     fi
333
334     [ -z "$DISTRO" ] && DISTRO=$(autodetect_distro)
335 }
336
337 # autodetect used Distro
338 autodetect_distro() {
339
340     local name
341     local version
342
343     if [ -f /etc/SuSE-release ]; then
344         name=sles
345         version=$(grep ^VERSION /etc/SuSE-release)
346         version=${version#*= }
347     elif [ -f /etc/redhat-release ]; then
348         name=$(head -1 /etc/redhat-release)
349         version=$(echo "$distroname" |
350                   sed -e 's/^[^0-9.]*//g' | sed -e 's/[ \.].*//')
351     fi
352     if [ -z "$name" -o -z "$version" ]; then
353         fatal 1 "I don't know how to determine distro type/version.\n" \
354                 "Either update autodetect_distro() or use the --distro argument"
355     fi
356
357     echo ${name}${version}
358     return 0
359
360 }
361
362 uniqify() {
363
364     echo $(echo "$*" | xargs -n 1 | sort -u)
365
366 }
367
368 download_srpm() {
369     local target=$1
370     local srpm=$2
371
372     echo "Downloading http://downloads.lustre.org/public/kernels/$target/old/$srpm..."
373     if ! wget -nv "http://downloads.lustre.org/public/kernels/$target/old/$srpm" \
374         -O "$KERNELDIR/$srpm"; then
375         fatal 1 "Could not download target $target's kernel SRPM $srpm from downloads.lustre.org."
376     fi
377     [ -s "$KERNELDIR/$srpm" ] || {
378         rm -rf $KERNELDIR/$srpm
379         fatal 1 "Could not download target $target's kernel SRPM $srpm from downloads.lustre.org."
380     }
381
382 }
383
384 download_ofed() {
385
386     if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ] && \
387        [ ! -r "$KERNELTREE/OFED-${OFED_VERSION}.tgz" ]; then
388         if $DOWNLOAD; then
389             local location="http://downloads.lustre.org/public/OFED/"
390             echo "Downloading $location/OFED-${OFED_VERSION}.tgz..."
391             if ! wget -nv "$location/OFED-${OFED_VERSION}.tgz" \
392                 -O "$KERNELTREE/OFED-${OFED_VERSION}.tgz"; then
393                 fatal 1 "Could not download OFED-${OFED_VERSION}.tgz" \
394                         "from downloads.lustre.org."
395             fi
396         else
397             fatal 1 "OFED-${OFED_VERSION}.tgz not found in kernel" \
398                     "directory $KERNELTREE."
399         fi
400     fi
401
402 }
403
404 load_target() {
405
406     EXTRA_VERSION_save="$EXTRA_VERSION"
407     for patchesdir in "$EXTERNAL_PATCHES" \
408                       "$TOPDIR/lustre/lustre/kernel_patches"; do
409         TARGET_FILE="$patchesdir/targets/$TARGET.target"
410         [ -r "$TARGET_FILE" ] && break
411     done
412     [ -r "$TARGET_FILE" ] || fatal 1 "Target $TARGET was not found."
413
414     echo "Loading target config file $TARGET.target..."
415
416     . "$TARGET_FILE"
417
418     # doesn't make any sense to build OFED for xen domX's
419     if $XEN; then
420         OFED_VERSION=""
421     fi
422
423     # XXX - set_rpm_smp_type is an ugly undeterministic hack.  it needs to
424     #       go away and the target just specify the $RPMSMPTYPE
425     [ -z "$RPMSMPTYPE" ] && set_rpm_smp_type
426
427     # CC might have been overwriten in TARGET_FILE
428     if [[ $CC != ccache\ * ]] && which "$CCACHE" 2>/dev/null; then
429         export CCACHE && export CC="ccache $CC"
430     fi
431
432     if [ ! "$KERNELTREE" = "" ] && [ -d "$KERNELTREE" ]; then
433         KERNELDIR="$KERNELTREE/${lnxmaj}"
434         [ -d "$KERNELDIR" ] || mkdir "$KERNELDIR"
435     fi
436
437     # verify the series is available
438     if [ "$SERIES" ]; then
439         for series in $SERIES; do
440             for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
441                 [ -r "$patchesdir/series/$series" ] && continue 2
442             done
443             fatal 1 "Target $TARGET's series $SERIES could not be" \
444                     "found.\nSearched:\n\t$EXTERNAL_PATCHES/series\n" \
445                     "\t$TOPDIR/lustre/lustre/kernel_patches/series."
446         done
447     fi
448
449     # set the location of the .config file
450     local XENPOSTFIX=""
451     if $XEN; then
452         XENPOSTFIX="-xen"
453     fi
454     if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH.config ]; then
455         CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH.config"
456     fi
457
458     # figure out our smp kernel type and set the .config if we have one
459     local smptype
460     for smptype in $SMPTYPES; do
461         [ "$smptype" = "''" ] && smptype=
462         if [ -f $TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET-$TARGET_ARCH-${smptype}.config ]; then
463             CONFIG_FILE="$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/kernel-$lnxmaj-$TARGET$XENPOSTFIX-$TARGET_ARCH-${smptype}.config"
464             KERNCONFSMPTYPE=$smptype
465     fi
466     done
467
468     local lnxrelnew=${lnxrel//-/_}
469
470     # remember the EXTRA_VERSION before we diddle it here
471     # XXX - we really should not diddle with any values read in from the
472     #       target file.  if we want to modify a value, we should create
473     #       a new variable.
474     PRISTINE_EXTRA_VERSION=$EXTRA_VERSION
475
476     if ! $PATCHLESS && [ ! -f "$CONFIG_FILE" ]; then
477         fatal 1 "Config file for target $TARGET missing from" \
478                 "$TOPDIR/lustre/lustre/kernel_patches/kernel_configs/."
479     fi
480
481     if [ "$EXTRA_VERSION_save" ]; then
482         EXTRA_VERSION="$EXTRA_VERSION_save"
483     elif ! $RELEASE; then
484         # if there is no patch series, then this is not a lustre specific
485         # kernel.  don't make it look like one
486         if [ -n "$SERIES" ]; then
487             #remove the @VERSION@ (lustre version)
488 #            EXTRA_VERSION=$(echo $EXTRA_VERSION | sed -e "s/\(.*_lustre\)\..*/\1/")
489 #            EXTRA_VERSION="${EXTRA_VERSION}-${TAG}.${TIMESTAMP}"
490             ! ( $PATCHLESS ) && EXTRA_VERSION="${EXTRA_VERSION}.${TIMESTAMP}"
491         fi
492     fi
493     # EXTRA_VERSION=${EXTRA_VERSION//-/_}
494
495     ALL_ARCHS="$BASE_ARCHS $BIGMEM_ARCHS $BOOT_ARCHS $JENSEN_ARCHS $SMP_ARCHS $BIGSMP_ARCHS $PSERIES64_ARCHS $UP_ARCHS"
496
497     BUILD_ARCHS=
498     for arch in $(uniqify "$ALL_ARCHS"); do
499         if [ -z "$TARGET_ARCHS" ] ||
500            [[ \ $TARGET_ARCHS\  = *\ $arch\ * ]]; then
501             BUILD_ARCHS="$BUILD_ARCHS $arch"
502         fi
503     done
504     [ "$BUILD_ARCHS" ] || usage 1 "No available target archs to build."
505     echo "Building for: $BUILD_ARCHS"
506 }
507
508 tarflags() {
509     local file="$1"
510
511     case "$file" in
512         '')
513             fatal 1 "tarflags(): File name argument missing."
514             ;;
515         *.tar.gz | *.tgz)
516             echo 'zxf'
517             ;;
518         *.tar.bz2)
519             echo 'jxf'
520             ;;
521         *.tar)
522             echo 'xf'
523             ;;
524         *)
525             fatal 1 "tarflags(): Unrecognized tar extension in file: $1"
526             ;;
527     esac
528
529 }
530
531 untar() {
532     local file="$1"
533
534     echo "Untarring ${file##*/}..."
535     tar $(tarflags "$file") "$file"
536
537 }
538
539 unpack_ofed() {
540
541     untar "$KERNELTREE/OFED-${OFED_VERSION}.tgz" || fatal 1 "Error unpacking OFED tarball"
542     [ -d OFED ] || ln -sf OFED-[0-9].[0-9]* OFED
543
544 }
545
546 unpack_lustre() {
547
548     if [ -z "$LUSTRE" ]; then
549         local DATESTAMP=""
550
551         if [ -n "$USE_DATESTAMP" ]; then
552             DATESTAMP="-D '$DATE'"
553         fi
554
555         local DIRNAME="lustre-$TAG-$TIMESTAMP"
556
557         cvs -d "$CVSROOT" -qz3 co $DATESTAMP -d "$DIRNAME" lustre || \
558             fatal 1 "There was an error checking out toplevel Lustre from CVS."
559         pushd "$DIRNAME" > /dev/null
560         ./lustrecvs "$TAG" || \
561             fatal 1 "There was an error checking out Lustre/Portals/Build from CVS."
562         echo "Creating lustre tarball..."
563         sh autogen.sh || fatal 1 "There was an error running autogen.sh."
564         ./configure --disable-{modules,utils,liblustre,tests,doc} || \
565             fatal 1 "There was an error running ./configure to create makefiles."
566         make dist || fatal 1 "There was an error running 'make dist'."
567         LUSTRE=$PWD/lustre-*.tar.gz
568         popd > /dev/null
569     fi
570
571     untar "$LUSTRE" || fatal 1 "Error unpacking Lustre tarball"
572     [ -d lustre ] || ln -sf lustre-[0-9].[0-9]* lustre
573
574 }
575
576 do_patch_linux() {
577
578     local do_patch=${1:-true}
579
580     FULL_PATCH="$PWD/lustre-kernel-${TARGET}${EXTRA_VERSION_DELIMITER}${EXTRA_VERSION}.patch"
581     [ -f "$FULL_PATCH" ] && rm -f "$FULL_PATCH"
582     $do_patch && pushd linux >/dev/null
583     for series in $SERIES; do
584         echo -n "Applying series $series:"
585         for patchesdir in "$EXTERNAL_PATCHES" "$TOPDIR/lustre/lustre/kernel_patches"; do
586             [ -r "$patchesdir/series/$series" ] || continue
587             SERIES_FILE="$patchesdir/series/$series"
588             for patch in $(<"$SERIES_FILE"); do
589                 echo -n " $patch"
590                 PATCH_FILE="$patchesdir/patches/$patch"
591                 [ -r "$PATCH_FILE" ] || \
592                     fatal 1 "Patch $patch does not exist in Lustre tree."
593                 cat "$PATCH_FILE" >> "$FULL_PATCH" || {
594                     rm -f $FULL_PATCH
595                     fatal 1 "Error adding patch $patch to full patch."
596                 }
597                 if $do_patch; then
598                     patch -s -p1 < "$PATCH_FILE" || {
599                         rm -f $FULL_PATCH
600                         fatal 1 "Error applying patch $patch."
601                     }
602                 fi
603             done
604             break
605         done
606         echo
607     done
608     $do_patch && popd >/dev/null
609     echo "Full patch has been saved in ${FULL_PATCH##*/}."
610
611 }
612
613 build_lustre() {
614
615     cp "$LUSTRE" SOURCES
616
617     pushd lustre >/dev/null
618
619     echo "Building Lustre RPMs for: $BUILD_ARCHS..."
620     targets=
621     for arch in $BUILD_ARCHS; do
622         targets="--target $arch $targets"
623     done
624
625     local confoptions="--with-linux=${LINUX}"
626     if $PATCHLESS; then
627         confoptions="--with-linux=${LINUX} --disable-server"
628     fi
629     if [ ! "$LINUXOBJ" = "" ]; then
630         confoptions="$confoptions --with-linux-obj=${LINUXOBJ}"
631     fi
632
633     ./configure $confoptions ${CONFIGURE_FLAGS}
634     if [ "$?" != "0" ]; then
635         local saved_config="../config.log.$(date +%s)"
636         cp config.log $saved_config
637         chmod a+r $saved_config
638         echo "Saved config.log is at $saved_config"
639         popd
640         return 255
641     fi
642
643     gen_lustre_version
644
645     # hack. Somebody move build/lustre.spec to lustre.spec for b1_6
646     local lustre_spec
647     [ -f lustre.spec ] && lustre_spec=lustre.spec
648     [ -f build/lustre.spec ] && lustre_spec=build/lustre.spec
649
650     [ -f "$lustre_spec" ] && sed \
651         -e "s^Release: .*$^Release: $LUSTRE_EXTRA_VERSION^" \
652         < $lustre_spec \
653         > ../lustre.spec
654
655     local rpmbuildopt='-bb'
656     if $NORPM; then
657         rpmbuildopt='-bc'
658         echo NORPM mode. Only compiling.
659     fi
660
661     if $PATCHLESS; then
662         rpmbuildopt="$rpmbuildopt --define \"lustre_name lustre-client\""
663     fi
664
665     $RPMBUILD $targets $rpmbuildopt ../lustre.spec \
666         --define "_tmppath $TMPDIR" \
667         --define "_topdir $TOPDIR" || \
668         fatal 1 "Error building rpms for $BUILD_ARCHS."
669
670     popd >/dev/null
671     ( $(skeep_ldiskfs_rpm $TAG) ) && return
672
673     pushd lustre/ldiskfs || return 255
674     make dist
675     if [ "$?" != "0" ]; then
676         popd
677         return 255
678     fi
679     cp lustre-ldiskfs*.tar.gz $TOPDIR/SOURCES
680
681     gen_lustre_version
682
683     local ldiskfs_spec=lustre-ldiskfs.spec
684     [ -f "$ldiskfs_spec" ] && sed \
685     -e "s^Release: .*$^Release: $LUSTRE_EXTRA_VERSION^" \
686     < $ldiskfs_spec \
687     > ../lustre-ldiskfs.spec
688
689     $RPMBUILD $targets $rpmbuildopt ../lustre-ldiskfs.spec \
690         --define "_tmppath /var/tmp" \
691         --define "_topdir $TOPDIR"
692     if [ "$?" != "0" ]; then
693         popd
694         return 255
695     fi
696
697     if $DO_SRC; then
698             $RPMBUILD -bs ../lustre-ldiskfs.spec \
699             --define "_tmppath /var/tmp" \
700             --define "_topdir $TOPDIR"
701         if [ "$?" != "0" ]; then
702             popd
703             return 255
704         fi
705     fi
706     popd
707
708 }
709
710 stage() {
711
712     [ "$STAGEDIR" ] || return 0
713
714     for arch in $BUILD_ARCHS; do
715         rpmdir="${STAGEDIR}/${CANONICAL_TARGET}-${arch}"
716         echo "${0##*/}: Copying RPMs into ${rpmdir}"
717         mkdir -p "${rpmdir}"
718         cp -v RPMS/${arch}/*.rpm "${rpmdir}"
719         if [ -d RPMS/noarch ]; then
720             cp -v RPMS/noarch/*.rpm "${rpmdir}"
721         fi
722     done
723
724     cp -v "$LUSTRE" "$STAGEDIR"
725 }
726
727 #check if we need to build separate ldiskfs RPM
728 skeep_ldiskfs_rpm() {
729         local tag="$1"
730
731         local skip=false
732
733         if ! $LDISKFSRPM; then
734             skip=true
735         elif $PATCHLESS; then
736             skip=true
737         else
738             for skiptag in $SKIPLDISKFSRPM; do
739                 [[ $tag == $skiptag ]] && skip=true && break
740             done
741         fi
742         echo $skip
743
744 }
745
746 #generate LUSTRE_EXTRA_VERSION from EXTRA_VERSION
747 gen_lustre_version() {
748
749     LUSTRE_EXTRA_VERSION="${lnxmaj}${EXTRA_VERSION_DELIMITER}${EXTRA_VERSION}${TARGET_DELIMITER}${RPMSMPTYPE:-${KERNCONFSMPTYPE:-"smp"}}"
750     LUSTRE_EXTRA_VERSION=${LUSTRE_EXTRA_VERSION//-/_}
751
752 }
753
754 set_rpm_smp_type() {
755
756     local infact_arch="${TARGET_ARCH}"
757
758     RPMSMPTYPE=default
759     [ "$infact_arch" == "i586" ] && infact_arch="i686"
760
761     local smp_type
762     for smp_type in $SMP_ARCHS; do
763         [ $infact_arch == $smp_type ] && RPMSMPTYPE=smp && break
764     done
765
766     for smp_type in $BIGSMP_ARCHS; do
767         [ $infact_arch == $smp_type ] && RPMSMPTYPE=bigsmp && break
768     done
769
770 }
771
772 # This function takes a linux source pool and digs out the linux release
773 # from it
774 find_linux_release() {
775     local SRCDIR="$1"
776
777     local LINUXRELEASEHEADER=$SRCDIR/include/linux/version.h
778     if [ -s $SRCDIR/include/linux/utsrelease.h ]; then
779         LINUXRELEASEHEADER=$SRCDIR/include/linux/utsrelease.h
780     fi
781
782     sed -ne 's/#define UTS_RELEASE "\(.*\)"$/\1/p' $LINUXRELEASEHEADER
783
784 }
785
786 find_linux_rpm() {
787     local prefix="$1"
788     local delimiter=${2:-"-"}
789
790     local pathtorpms="${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
791     [ -d $pathtorpms ] || return 255
792
793     local kernelbinaryrpm rpmfile
794     local wanted_kernel="${lnxmaj}${delimiter}${lnxrel}"
795
796     local arch ret=1
797     for arch in $TARGET_ARCHS_ALL; do
798         local found_rpm="" rpm
799         for rpm in ${pathtorpms}/${arch}/*.rpm; do
800             if rpm -q --provides -p "$rpm" | grep -q "kernel${prefix} = $wanted_kernel"; then
801                 found_rpm="$rpm"
802                 ret=0
803                 break
804             fi
805         done
806         [ -f "$found_rpm" ] && TARGET_ARCH="$arch" && BUILD_ARCHS="$arch" && break
807     done
808
809     echo "$found_rpm"
810     return $ret
811
812 }
813
814 #unpack kernel(/source/devel) RPM
815 #
816 # This function and it's setting of $LINUX and $LINUXOBJ is a total hack that
817 # needs to completely refactored.  It completely ingores that $BUILD_ARCHS may
818 # contain a list of arches for which rpmbuild commands (including the one for
819 # lustre itself)
820 unpack_linux_rpm() {
821     local kernelrpm="${1}"
822     local delimiter=${2:-"-"}
823
824     [ -f "$kernelrpm" ] || return 255
825     [ -d $TOPDIR/reused ] || mkdir $TOPDIR/reused
826
827     pushd $TOPDIR/reused || return 255
828
829     local RC=0
830
831     rpm2cpio < "$kernelrpm" | cpio -id > /dev/null 2>&1
832     if [ ${PIPESTATUS[0]} -eq 0 ]; then
833         # RHEL-style and SLES-style rpms
834         local paths="kernels/${lnxmaj}${delimiter}${lnxrel}-${TARGET_ARCH} linux-${lnxmaj}${delimiter}${lnxrel}"
835
836         local path
837         for path in $paths; do
838             local src='usr/src'
839
840             if [ -d "$src/$path/" ]; then
841                 LINUX="$(pwd)/$src/$path"
842             fi
843             # SLES has a separate -obj tree
844             if [ -d "$src/${path}-obj" ]; then
845                 local src="$src/${path}-obj"
846                 local objects="$TARGET_ARCH/$RPMSMPTYPE"
847
848                 # Novell, are you *TRYING* to make life hard for me?
849                 if [ -d "$src/powerpc" ]; then
850                     objects="powerpc/$TARGET_ARCH"
851                 elif [ $TARGET_ARCH == 'i686' ]; then
852                     objects="i386/$RPMSMPTYPE"
853                 fi
854
855                 LINUXOBJ="$(pwd)/$src/$objects"
856             fi
857         done
858         if [ -z "$LINUX" ]; then
859             RC=255
860         else
861             # dig out the release version
862             LINUXRELEASE=$(find_linux_release ${LINUXOBJ:-$LINUX})
863             if [ -z "$LINUXRELEASE" ]; then
864                 echo "Failed to find linux release in ${LINUXOBJ:-$LINUX}"
865                 RC=255
866             fi
867         fi
868     else
869         RC=255
870     fi
871     popd
872     return $RC
873 }
874
875 build_kernel_ib() {
876     # build kernel-ib{,-devel}
877     # some I/B drivers are architecture dependent and kernel-ib's configure
878     # does not figure it out for us ~sigh~
879     local configure_options=""
880     case "$TARGET_ARCH" in
881         x86_64 | ia64)
882             configure_options="--with-ipath_inf-mod"
883             ;;
884         ppc64)
885             configure_options="--with-ipath_inf-mod --with-ehca-mod"
886             ;;
887     esac
888     local K_SRC="K_SRC"
889     # ofed 1.3 had a bug in the rpm spec
890     if [ "$OFED_VERSION" = "1.3" ]; then
891         K_SRC="KSRC"
892     fi
893     $RPMBUILD --rebuild --define 'build_kernel_ib 1' --define 'build_kernel_ib_devel 1' \
894               --define "_topdir ${TOPDIR}" --target ${TARGET_ARCH} \
895               --define "KVERSION ${LINUXRELEASE}" \
896               --define "$K_SRC ${LINUXOBJ:-${LINUX}}" \
897               --define "LIB_MOD_DIR /lib/modules/${LINUXRELEASE}/updates" \
898               --define "configure_options --without-quilt --with-core-mod --with-user_mad-mod --with-user_access-mod --with-addr_trans-mod --with-srp-target-mod --with-core-mod --with-mthca-mod --with-mlx4-mod --with-cxgb3-mod --with-nes-mod --with-ipoib-mod --with-sdp-mod --with-srp-mod --without-srp-target-mod --with-rds-mod --with-iser-mod --with-qlgc_vnic-mod --with-madeye-mod $configure_options" ${TOPDIR}/OFED/SRPMS/ofa_kernel-${OFED_VERSION}-ofed${OFED_VERSION}.src.rpm
899
900     if [ ${PIPESTATUS[0]} != 0 ]; then
901         fatal 1 "Error building kernel-ib"
902     fi
903
904     pushd "$TOPDIR" >/dev/null
905     rm -rf kernel-ib-devel
906     mkdir kernel-ib-devel
907     cd kernel-ib-devel
908     local rpm=$(ls $TOPDIR/RPMS/*/kernel-ib-devel-${OFED_VERSION}-${LINUXRELEASE//-/_}.*.rpm)
909     rpm2cpio -itv < $rpm | cpio -id
910     CONFIGURE_FLAGS="--with-o2ib=$(pwd)/usr/src/ofa_kernel ${CONFIGURE_FLAGS}"
911     popd >/dev/null
912 }
913
914 store_for_reuse() {
915         local articles="$1"
916         local module="$2"
917         local location="$3"
918         local signature="$4"
919         local use_links="$5"
920
921         local linkflag=""
922         if $use_links; then
923             linkflag="l"
924         fi
925
926         location="$location"/"$signature"/"$module"
927         mkdir -p "$location"
928         ## use eval/echo here to make sure shell expansions are performed
929         #if ! cp -a${linkflag} $(eval echo $articles) "$location"; then
930         local article
931         for article in $(eval echo $articles); do
932             if ! cp -a${linkflag} "$article" "$location"; then
933                 error "Failed to copy \"$article\" to \"$location\" in store_for_reuse()"
934                 return 1
935             fi
936         done
937
938         return 0
939
940 }
941
942 reuse() {
943     local module="$1"
944     local dest="$2"
945     local use_links="${3:-false}"
946     local signature="$4"
947
948     if [ -n "$REUSEBUILD" ] && [ -d $REUSEBUILD/$signature/$module ]; then
949         # so that we know how stale this entry is
950         touch $REUSEBUILD/$signature/$module/.lastused
951         if $use_links; then
952             if ls $REUSEBUILD/$signature/$module/* >/dev/null 2>&1; then
953                 cp -al $REUSEBUILD/$signature/$module/* $dest/
954             fi
955         else
956             # copying is pretty heavy
957             # cp -a $REUSEBUILD/$signature/$module/* $dest/
958             # do some creative symlinking instead
959             local dir
960             for dir in BUILD SRPMS SPECS; do
961                 if ls $REUSEBUILD/$signature/$module/$dir/* >/dev/null 2>&1; then
962                     ln -s $REUSEBUILD/$signature/$module/$dir/* $dest/$dir
963                 fi
964             done
965             # sources have to be copied by file because we need SOURCES to
966             # be a dir we can write into
967 # could overrun ls's arg list here
968             #ls $REUSEBUILD/$signature/$module/SOURCES/* |
969             find $REUSEBUILD/$signature/$module/SOURCES/ -type f |
970                 xargs ln -t $dest/SOURCES -s
971
972             # same for RPMS/* dirs
973 # could overrun ls's arg list here
974             #ls $REUSEBUILD/$signature/$module/RPMS/$TARGET_ARCH/* |
975             local dir
976             for dir in $REUSEBUILD/$signature/$module/RPMS/*; do
977                 mkdir -p $dest/RPMS/${dir##*/}
978                 find $dir -type f |
979                   xargs ln -t $dest/RPMS/${dir##*/} -s
980             done
981                      
982         fi
983         return 0
984     else
985         return 1
986     fi
987 }
988
989 basearch() {
990     local arch="$1"
991
992     if [[ $arch = i[3456]86 ]]; then
993         echo "i386"
994     else
995         echo "$arch"
996     fi
997
998 }
999
1000 build_kernel_with_srpm() {
1001
1002     # need to generate the patch for this target
1003     do_patch_linux false >&2    # sets global $FULL_PATCH (yeah, yuck)
1004
1005     # get an md5sum of the kernel patch + config for reuse check
1006     # XXX really, there needs to be a signature and a CONFIG_FILE per arch
1007     #     in BUILD_ARCHS
1008     local REUSE_SIGNATURE=$(cat $CONFIG_FILE $TARGET_FILE $FULL_PATCH | md5sum | cut -d" " -f1)
1009
1010     # see if we can link to the reuse pool
1011     # XXX - hrm.  i'm not convinced this doesn't belong in the reuse "library"
1012     local CAN_LINK_FOR_REUSE=false
1013     touch $REUSEBUILD/$$
1014     if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1015         CAN_LINK_FOR_REUSE=true
1016     fi
1017     rm $REUSEBUILD/$$
1018
1019     # the extra version string to use for the kernel (which might be a reused
1020     # kernel, remember)
1021     local kernel_extra_version=""
1022     if $REUSERPM && reuse kernel "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1023                                  "$REUSE_SIGNATURE"; then
1024         # figure out the EXTRA_VERSION of the kernel we are re-using
1025         kernel_extra_version=$(ls $TOPDIR/RPMS/$TARGET_ARCH/kernel-lustre-*${lnxmaj}${EXTRA_VERSION_DELIMITER}${PRISTINE_EXTRA_VERSION}.*.$TARGET_ARCH.rpm)
1026         kernel_extra_version=${kernel_extra_version##*kernel-lustre-*${lnxmaj}${EXTRA_VERSION_DELIMITER}}
1027         kernel_extra_version=${kernel_extra_version%%.$TARGET_ARCH.rpm}
1028     else
1029         # nothing cached, build from scratch
1030         if [ ! -r "$KERNELDIR/$KERNEL_SRPM" ]; then
1031             download_srpm "$CANONICAL_TARGET" "$KERNEL_SRPM"
1032         fi
1033
1034         rpm -ivh $KERNELDIR/$KERNEL_SRPM --define "_topdir $TOPDIR" >&2 || {
1035         # should we clean this up or leave it for analysis?
1036             #rm -rf $RPMTOPDIR
1037             fatal 1 "Error installing kernel SRPM."
1038         }
1039
1040         # put the Lustre kernel patch into the RPM build tree
1041         cp $FULL_PATCH $TOPDIR/SOURCES/linux-${lnxmaj}-lustre.patch
1042         prepare_and_build_srpm
1043
1044         # store the resulting kernel RPM build tree for future use
1045         if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1046                              "kernel" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1047                              "$CAN_LINK_FOR_REUSE"; then
1048             error "Failed to store kernel RPMS for reuse"
1049             echo "unknown"
1050             return 1
1051         fi
1052         kernel_extra_version=$EXTRA_VERSION
1053     fi  # build reuse
1054
1055     # should now have the following RPMs
1056     # $TOPDIR/RPMS/$arch/kernel-lustre-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1057     # $TOPDIR/RPMS/$arch/kernel-lustre-devel-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1058     # $TOPDIR/RPMS/$arch/kernel-lustre-headers-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1059     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-common-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1060     # $TOPDIR/RPMS/$arch/kernel-lustre-debuginfo-2.6.18-53.1.21.el5_lustre.1.6.5.1.$arch.rpm
1061
1062     echo $kernel_extra_version
1063     return 0
1064
1065 }
1066
1067 build_with_srpm() {
1068
1069     if ! $PATCHLESS; then
1070         local kernel_extra_version
1071         if ! kernel_extra_version=$(build_kernel_with_srpm); then
1072             fatal 1 "Failed to build the kernel from it's SRPM"
1073         fi
1074 #local kernel_extra_version="60-0.33_lustre.1.8.0.50.20090311172757"
1075
1076         for arch in $BUILD_ARCHS; do
1077
1078             local kernel_devel_rpm="$TOPDIR/RPMS/$arch/$(devel_kernel_name true)-$lnxmaj$EXTRA_VERSION_DELIMITER$kernel_extra_version.$arch.rpm"
1079
1080             # install the -devel RPM in preparation for the lustre build
1081             if ! lnxrel="$kernel_extra_version" unpack_linux_rpm \
1082                            $kernel_devel_rpm $EXTRA_VERSION_DELIMITER; then
1083                 fatal 1 "Could not find the Linux tree in $kernel_devel_rpm"
1084             fi
1085
1086             # XXX - superhack of all superhacks!  kernel-lustre-devel doesn't
1087             #       have have sources in it, so we need to pull them out of
1088             #       the SRPM
1089             #       yeah.  blech.
1090             cp BUILD/kernel-lustre-${lnxmaj}/linux-${lnxmaj}.$arch/fs/ext3/*.[ch] \
1091                $TOPDIR/reused/usr/src/kernels/${lnxmaj}${EXTRA_VERSION_DELIMITER}${kernel_extra_version}-${arch}/fs/ext3
1092         done
1093     else
1094         # need to find and unpack the vendor's own kernel-devel for patchless
1095         # client build
1096         local kernelrpm
1097         if ! kernelrpm=$(find_linux_rpm "-$DEVEL_KERNEL_TYPE" ${EXTRA_VERSION_DELIMITER:-"-"}); then
1098             fatal 1 "Could not find the kernel-$DEVEL_KERNEL_TYPE RPM in ${KERNELRPMSBASE}/${lnxmaj}/${DISTRO}"
1099         fi
1100         if ! lnxrel="$lnxrel" unpack_linux_rpm "$kernelrpm" \
1101                                                "${EXTRA_VERSION_DELIMITER:--}"; then
1102             fatal 1 "Could not find the Linux tree in $kernelrpm"
1103         fi
1104     fi
1105
1106     # before lustre, build kernel-ib
1107     if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1108         # see if we can link to the reuse pool
1109         # XXX - hrm.  i'm not convinced this doesn't belong in the reuse "library"
1110         local CAN_LINK_FOR_REUSE=false
1111         touch $REUSEBUILD/$$
1112         if cp -al $REUSEBUILD/$$ $TOPDIR/; then
1113             CAN_LINK_FOR_REUSE=true
1114         fi
1115         rm $REUSEBUILD/$$
1116
1117         local REUSE_SIGNATURE=$({ echo "$OFED_VERSION"; echo "$(find_linux_release ${LINUXOBJ:-$LINUX})"; cat "${LINUXOBJ:-${LINUX}}/include/linux/autoconf.h"; } | md5sum | cut -d" " -f1)
1118         if ! reuse ofed "$TOPDIR" "$CAN_LINK_FOR_REUSE" \
1119                         "$REUSE_SIGNATURE"; then
1120             # stash away the existing built articles for a moment
1121             mkdir bak
1122             mv {BUILD,{S,}RPMS,S{OURCE,PEC}S} bak
1123             function mv_back {
1124                 pushd bak
1125                 find . | cpio -pudlm ..
1126                 popd
1127                 rm -rf bak
1128             }
1129             create_rpmbuild_dirs
1130             # build it
1131             build_kernel_ib
1132             if ! store_for_reuse "$TOPDIR/{SPECS,SOURCES,BUILD,SRPMS,RPMS}" \
1133                                  "ofed" "$REUSEBUILD" "$REUSE_SIGNATURE" \
1134                                  "$CAN_LINK_FOR_REUSE"; then
1135                 error "Failed to store OFED RPMS for reuse"
1136                 mv_back
1137                 return 1
1138             fi
1139             # put the stuff we stashed away back
1140             mv_back
1141         fi
1142     fi
1143
1144     # now build Lustre
1145     if build_lustre; then
1146         # the build worked.  resolve any symlinked files (i.e. from reuse)
1147         # in RPMS/$arch to real files so that that that huge mess of
1148         # complication knows as LTS can copy them yet somewhere else.
1149         # is it any wonder this whole process is so damn so?  anyone ever
1150         # heard of hardlinks?  it this cool new thing that allows you save
1151         # tons of time and space by creating... well you can go read about
1152         # them if you have not heard about them yet.
1153         # can i say how much the implemenation of all of this really impedes
1154         # RPM reuse?
1155         pushd RPMS/$TARGET_ARCH
1156             for file in *; do
1157                 if [ -h $file ]; then
1158                     cp $file foo
1159                     mv foo $file
1160                 fi
1161             done
1162         popd
1163     fi
1164 }
1165
1166 create_rpmbuild_dirs() {
1167
1168     if [ ! -d RPMS ]; then
1169         mkdir -p RPMS
1170         for arch in $BUILD_ARCHS; do
1171             mkdir RPMS/$arch
1172         done
1173     fi
1174     [ -d BUILD ] || mkdir BUILD
1175     [ -d SOURCES ] || mkdir SOURCES
1176     [ -d SPECS ] || mkdir SPECS
1177     [ -d SRPMS ] || mkdir SRPMS
1178
1179 }
1180
1181 new_list() {
1182
1183     echo ""
1184
1185 }
1186
1187 add_list() {
1188     local list="$1"
1189     local item="$2"
1190
1191     echo "$list $item"
1192
1193 }
1194
1195 is_list_member() {
1196     local list="$1"
1197     local item="$2"
1198
1199     [[ $list\  == *\ $item\ * ]]
1200
1201 }
1202
1203 #########################################################################
1204 # Generate a backtrace through the call stack.
1205 #
1206 # Input: None
1207 # Output: None
1208 #########################################################################
1209 backtrace() {
1210     local strip=${1:-1}
1211
1212     local funcname="" sourcefile="" lineno="" n
1213
1214     echo "Call stack: (most recent first)"
1215     for (( n = $strip ; n < ${#FUNCNAME[@]} ; ++n )) ; do
1216         funcname=${FUNCNAME[$n - 1]}
1217         sourcefile=$(basename ${BASH_SOURCE[$n]})
1218         lineno=${BASH_LINENO[$n - 1]}
1219         # Display function arguments
1220         if [[ ! -z "${BASH_ARGV[@]}" ]]; then
1221             local args newarg j p=0
1222             for (( j = ${BASH_ARGC[$n - 1]}; j > 0; j-- )); do
1223                 newarg=${BASH_ARGV[$j + $p - 1]}
1224                 args="${args:+${args} }'${newarg}'"
1225             done
1226             let p+=${BASH_ARGC[$n - 1]}
1227         fi
1228         echo "  ${funcname} ${args:+${args} }at ${sourcefile}:${lineno}"
1229     done
1230
1231     echo
1232     echo "BEGIN BACKTRACE"
1233
1234     #echo ${BASH_LINENO[*]}
1235     #echo ${BASH_SOURCE[*]}
1236     #echo ${FUNCNAME[*]}
1237     local i=$((${#FUNCNAME[@]} - 1))
1238     while [ $i -ge 0 ]; do
1239         local SOURCELINE="${BASH_SOURCE[$i + 1]}:${BASH_LINENO[$i]}"
1240         # Can't figure out how to get function args from other frames...
1241         local FUNCTION="${FUNCNAME[$i]}()"
1242         echo "$SOURCELINE:$FUNCTION"
1243         i=$((i - 1))
1244     done
1245
1246     echo "END BACKTRACE"
1247
1248     echo $BACKTRACE
1249
1250 }
1251
1252 [ -r ~/.lbuildrc ] && . ~/.lbuildrc
1253
1254 options=$(getopt -o d:D:h -l kerneltree:,distro:,kernelrpm:,reusebuild:,patchless,ldiskfs,ccache,reuse:,norpm,disable-datestamp,external-patches:,timestamp:,extraversion:,kerneldir:,linux:,lustre:,nodownload,nosrc,publish,release,src,stage:,tag:,target:,target-archs:,with-linux:,xen -- "$@")
1255
1256 if [ $? != 0 ]; then
1257     usage 1
1258 fi
1259
1260 eval set -- "$options"
1261
1262 while [ "$1" ]; do
1263     case "$1" in
1264         '')
1265             usage 1
1266             ;;
1267         --ccache)
1268             CCACHE='ccache'
1269             shift
1270             ;;
1271         -d)
1272             CVSROOT=$2
1273             shift 2
1274             ;;
1275         -D)
1276             DATE=$2
1277             shift 2
1278             ;;
1279         --external-patches)
1280             EXTERNAL_PATCHES=$2
1281             shift 2
1282             ;;
1283         --extraversion)
1284             EXTRA_VERSION=$2
1285             shift 2
1286             ;;
1287         --help | -h)
1288             usage 0
1289             ;;
1290         --kerneldir)
1291             KERNELDIR=$2
1292             shift 2
1293             ;;
1294         --kerneltree)
1295             if ! KERNELTREE=$(canon_path "$2"); then
1296                 fatal 1 "Could not determine the canonical location of $2"
1297             fi
1298             shift 2
1299             ;;
1300         --linux | --with-linux)
1301             if ! LINUX=$(canon_path "$2"); then
1302                 fatal 1 "Could not determine the canonical location of $2"
1303             fi
1304             shift 2
1305             ;;
1306         --distro)
1307             DISTRO=$2
1308             shift 2
1309             ;;
1310         --reuserpm)
1311             REUSERPM=$2
1312             shift 2
1313             ;;
1314         --reusebuild)
1315             if ! REUSEBUILD=$(canon_path "$2"); then
1316                 fatal 1 "Could not determine the canonical location of $2"
1317             fi
1318             shift 2
1319             ;;
1320         --norpm)
1321             NORPM=true
1322             shift
1323             ;;
1324         --ldiskfs)
1325             LDISKFSRPM=true
1326             shift
1327             ;;
1328         --patchless)
1329             PATCHLESS=true
1330             shift
1331             ;;
1332         --kernelrpm)
1333             if ! KERNELRPMSBASE=$(canon_path "$2"); then
1334                 fatal 1 "Could not determine the canonical location of $2"
1335             fi
1336             shift 2
1337             ;;
1338         --timestamp)
1339             TIMESTAMP=$2
1340             shift 2
1341             ;;
1342         --lustre)
1343             LUSTRE=$2
1344             shift 2
1345             ;;
1346         --nodownload)
1347             DOWNLOAD=false
1348             shift 1
1349             ;;
1350         --nosrc)
1351             DO_SRC=false
1352             shift 1
1353             ;;
1354         --publish)
1355             shift
1356             ;;
1357         --release)
1358             RELEASE=true
1359             shift
1360             ;;
1361         --src)
1362             DO_SRC=true
1363             shift 1
1364             ;;
1365         --stage)
1366             STAGEDIR=$2
1367             shift 2
1368             ;;
1369         --tag)
1370             TAG=$2
1371             shift 2
1372             ;;
1373         --target)
1374             TARGET=$2
1375             shift 2
1376             ;;
1377         --target-archs)
1378             TARGET_ARCHS=$2
1379             shift 2
1380             ;;
1381         --disable-datestamp)
1382             USE_DATESTAMP=
1383             shift
1384             ;;
1385         --xen)
1386             XEN=true
1387             shift
1388             ;;
1389         --)
1390             shift
1391             CONFIGURE_FLAGS=$@
1392             CONFIGURE_FLAGS="$CONFIGURE_FLAGS --enable-liblustre --enable-liblustre-tests"
1393             break
1394             ;;
1395         *)
1396             usage 1 "Unrecognized option: $1"
1397             ;;
1398     esac
1399 done
1400
1401 check_options
1402
1403 unpack_lustre
1404
1405 load_target
1406 EXTRA_VERSION_DELIMITER=${EXTRA_VERSION_DELIMITER:-"-"}
1407
1408 if [ -n "$OFED_VERSION" -a "$OFED_VERSION" != "inkernel" ]; then
1409     download_ofed
1410     unpack_ofed
1411 fi
1412
1413 # make sure the RPM build environment is set up
1414 create_rpmbuild_dirs
1415
1416 trap '[ -n "$CCACHE" ] && ccache -s' EXIT
1417
1418 # if an unpacked kernel source tree was given on the command line
1419 # just build lustre with it (nothing distro kernel specific here)
1420 if [ -n "$LINUX" ]; then
1421     build_lustre
1422 else
1423     if [ -f "${0%/*}/lbuild-$DISTRO" ]; then
1424         seen_list=$(new_list)
1425         trap '(echo "Untrapped error"
1426 echo
1427 # have we seen this one
1428 echo "checking seen list for ${BASH_SOURCE[0]}:${BASH_LINENO[0]}"
1429
1430 if is_list_member "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}"; then
1431   echo "seen this one already"
1432 else
1433   seen_list=$(add_list "$seen_list" "${BASH_SOURCE[0]}:${BASH_LINENO[0]}")
1434 fi
1435 backtrace
1436 echo
1437 echo "Environment:"
1438 set
1439 ) | tee >(mail -s "Untrapped error in lbuild on $MACHINENAME" brian@sun.com) >&2' ERR
1440         set -E
1441
1442         source ${0%/*}/lbuild-$DISTRO
1443
1444         build_with_srpm || fatal 1 "Failed to build_with_srpm"
1445     else
1446         source ${0%/*}/lbuild.old_school
1447
1448         old_school_download_kernel
1449
1450         build_success=false
1451         if $PATCHLESS; then
1452             patchless_build_sequence && build_success=true
1453         else
1454             [ "$DISTRO" = "sles9" ] && build_sequence_rpm_reuse && build_success=true
1455             if ! $build_success; then
1456                 build_sequence_reuse && build_success=true
1457                 if ! $build_success; then
1458                     build_sequence && build_success=true
1459                     if $build_success; then
1460                         store_for_reuse || echo "Cannot store for future reuse"
1461                     fi
1462                 fi
1463             fi
1464         fi
1465         ( $build_success ) || fatal 1 "Cannot build lustre"
1466     fi
1467 fi
1468
1469 stage